$(document).ready(function() {
	var elapsed = 0;
	var interval;
	var limit = 60 * 60;
	var totalMinutes = 0;
	var answers = [];
	var submittedAnswers = [];
	var currentQuestion = 1;
	var questionCount = $("li[class*=question]").length;
	$(".question:gt(0)").hide();
	$("#results-button").hide();
	
	$("#questions li").attr("contentEditable", "false");
	$("#questions h2").attr("contentEditable", "false");
	
	$("#next-question-button").removeAttr("disabled");
	
	if (currentQuestion == 1) {
		$("#last-question-button").attr("disabled", "disabled");
	} else {
		$("#last-question-button").removeAttr("disabled");
	}
	
	$("#next-question-button").click(function() {
		if (submittedAnswers[currentQuestion] != undefined) {
			$("#questions #" + currentQuestion).hide();
			currentQuestion = currentQuestion + 1;
			$("#questions #" + currentQuestion).fadeIn();
			
			if (currentQuestion==questionCount) {
				$("#next-question-button").attr("disabled", "disabled");
				$("#results-button").fadeIn();
			} else {
				$("#next-question-button").removeAttr("disabled");
			}
		
			if (currentQuestion == 1) {
				$("#last-question-button").attr("disabled", "disabled");
			} else {
				$("#last-question-button").removeAttr("disabled");
			}
			answerSelected = "false";
		} else {
			alert("Please select an answer.");
		}
	});
	
	$("#last-question-button").click(function() {
		$("#questions #" + currentQuestion).hide();
		currentQuestion = currentQuestion - 1;
		$("#questions #" + currentQuestion).fadeIn();
		
		if (currentQuestion==questionCount.length) {
			$("#next-question-button").attr("disabled", "disabled");
		} else {
			$("#next-question-button").removeAttr("disabled");
			$("#results-button").fadeOut();
		}
		
		if (currentQuestion == 1) {
			$("#last-question-button").attr("disabled", "disabled");
		} else {
			$("#last-question-button").removeAttr("disabled");
		}
	});
	
	function showElapsedTime() {
		if (elapsed < limit) {
			elapsed += 1;

			if (elapsed == 60) {
				totalMinutes += 1;
				elapsed = 0;
			}
			if (elapsed < 10) {
				$("#elapsed").html("Time elapsed: <b>" + totalMinutes + ":0" + elapsed + "</b>");
			} else {
				if (elapsed != 60) {
					$("#elapsed").html("Time elapsed: <b>" + totalMinutes + ":" + elapsed + "</b>");                
				} else {
					$("#elapsed").html("Time elapsed: <b>" + totalMinutes + ":00</b>");                    
				}
			}    
		} else {
			clearInterval(interval);
			alert("Sorry, time has ran out");
		}
	}
	function stopTime() {
		clearInterval(interval);
	}

	$(function() {
		interval = setInterval(showElapsedTime, 1000);
	});

	$("ul.answers li").click(function() {
		var questionId = $(this).parent().parent().attr("id");
		var answerClass = $(this).attr("class");
		var listParent;

		$(this).parent().find("li").css({'background-color': '#ffffff', 'color': '#000000'});
		$(this).css({'background-color': '#555555', 'color': '#ffffff'});

		if (answerClass.indexOf("correct") != -1) {
			answers[questionId] = "correct";
		} else {
			answers[questionId] = "incorrect";
		}
		answerClass = answerClass.replace("correct ", "");
		submittedAnswers[questionId] = answerClass;
		answerSelected = "true";
	});

	$("#results-button").click(function() {
		var numberCorrect = 0;
		var numberIncorrect = 0;
		var incorrectString = "";
		var incorrect = [];
		var correct = [];
		
		$("#results").html("");
		stopTime();
		
		if (submittedAnswers[currentQuestion] != undefined) {
			for (var i = 1; i <= questionCount; i++) {
				if (answers[i] == "correct") {
					numberCorrect++;
					correct[numberCorrect] = i;
				} else {
					incorrectString += "<div class='incorrect'>You got question " + i + " wrong.</div>";
					numberIncorrect++;
					incorrect[numberIncorrect] = i;
				}
			}
			
			if (incorrect.length > 0) {
				for (var i = 1; i <= incorrect.length; i++) {
					$("ul").find("#" + incorrect[i]).find("img").fadeIn();
					$("ul").find("#" + incorrect[i]).css("background-color", "red");
				}
			}

			$.each(correct,function(key, value) {
				$("ul").find("#" + incorrect[value]).find("img").fadeIn();
			});

			var percentCorrect = (100/questionCount) * numberCorrect;

			$("#results").html("<div class='correct'>Congratulations, you got <b>" + numberCorrect + "</b> questions correct out of <b>" + questionCount + "</b> questions in <b>" + totalMinutes + "</b> minutes and <b>" + elapsed + "</b> seconds. That's <b>" + percentCorrect.toFixed(1) + "%</b> correct!</div>" + incorrectString);
			
			$("#questions").find("*").fadeIn();
		
			$("#results").fadeIn();
			$(document).scrollTop(0);
		
			$("#last-question-button").hide();
			$("#next-question-button").hide();
			$("#results-button").hide();
			$("#retake").show();
		} else {
			alert("Please select an answer.");
		}
	});
	$("#retake").click(function() {
		location.reload();
	});
});